<?php
/**
 * @author Rafael Ostertag <rafael.ostertag@math.uzh.ch>
 */

namespace IMATHUZH\Qfq\Controller;

use qfq;

require_once(__DIR__ . '/../../qfq/qfq/QuickFormQuery.php');
require_once(__DIR__ . '/../../qfq/qfq/exceptions/UserException.php');
require_once(__DIR__ . '/../../qfq/qfq/exceptions/CodeException.php');
require_once(__DIR__ . '/../../qfq/qfq/exceptions/DbException.php');

class QfqController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController {
    public function showAction() {


        try {
            $contentObject = $this->configurationManager->getContentObject();
            $qfq = new \qfq\QuickFormQuery($contentObject->data);
            $html = $qfq->process();

        } catch (qfq\UserException $e) {
            $html = $e->formatMessage();
        } catch (qfq\CodeException $e) {
            $html = $e->formatMessage();
        } catch (qfq\DbException $e) {
            $html = $e->formatMessage();
        } catch (\Exception $e) {
            $html = "Generic Exception: " . $e->getMessage();
        }

        $this->view->assign('qfqOutput', $html);
        return $this->view->render();
    }

}