<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 1/12/16
 * Time: 9:28 AM
 */

namespace qfq;

require_once(__DIR__ . '/../../qfq/helper/OnArray.php');


class OnArrayTest extends \PHPUnit_Framework_TestCase {
    public function testSortByKey() {
        $unsorted = [
            'a' => 'z',
            '1' => 'y',
            'Aa' => 'y0',
            'zZ' => 'X9',
            '0000' => 'h'
        ];

        $sorted = [
            '0000' => 'h',
            '1' => 'y',
            'Aa' => 'y0',
            'a' => 'z',
            'zZ' => 'X9'
        ];

        $expected = $unsorted;
        OnArray::sortKey($expected);
        $this->assertEquals($sorted, $expected);

        $expected = array();
        OnArray::sortKey($expected);
        $this->assertEquals(array(), $expected);

    }

    public function testTrimArray() {
        $raw = ['hello', '"next"', '"without trailing', 'without leading"', ' with whitespace ', '" with tick and whitespace "', ''];
        $expected = ['hello', 'next', 'without trailing', 'without leading', ' with whitespace ', ' with tick and whitespace ', ''];

        $this->assertEquals(OnArray::trimArray($raw, '"'), $expected);
    }
}
