/**
 * @author Rafael Ostertag <rafael.ostertag@math.uzh.ch>
 */

if (!QfqNS) {
    var QfqNS = {};
}

if (!QfqNS.Element) {
    QfqNS.Element = {};
}

(function (n) {
    'use strict';

    n.Element = function ($element) {
        if (!$element || $element.length === 0) {
            throw new Error("No element");
        }

        this.formGroup = new n.FormGroup($element);
    };

    n.Element.prototype.isType = function (type) {
        var lowerCaseType = type.toLowerCase();
        var isOfType = true;
        this.formGroup.$element.each(function () {
            if (this.hasAttribute('type')) {
                if (this.getAttribute('type') === lowerCaseType) {
                    return true;
                } else {
                    isOfType = false;
                    return false;
                }
            } else {
                if (lowerCaseType === 'text') {
                    return true;
                } else {
                    isOfType = false;
                    return false;
                }
            }
        });

        return isOfType;
    };
})(QfqNS.Element);