/**
 * @author Rafael Ostertag <rafael.ostertag@math.uzh.ch>
 */

if (!QfqNS) {
    var QfqNS = {};
}

if (!QfqNS.Element) {
    QfqNS.Element = {};
}

(function (n) {
    'use strict';


    /**
     *
     * @param $element
     * @constructor
     */
    function Radio($element) {
        n.Element.call(this, $element);

        if (!this.isType("radio")) {
            throw new Error("$element is not of type 'radio'");
        }
    }

    Radio.prototype = Object.create(n.Element.prototype);
    Radio.prototype.constructor = Radio;

    Radio.prototype.setValue = function (val) {
        this.formGroup.$element.prop('checked', false);
        this.formGroup.$element.filter('[value=' + val + "]").prop('checked', true);
    };

    Radio.prototype.getValue = function () {
        return this.formGroup.$element.filter(':checked').val();
    };

    n.Radio = Radio;

})(QfqNS.Element);