/**
 * @author Rafael Ostertag <rafael.ostertag@math.uzh.ch>
 */

/* global $ */

if (!QfqNS) {
    var QfqNS = {};
}

if (!QfqNS.Helper) {
    QfqNS.Helper = {};
}

(function (n) {
    'use strict';

    n.FunctionList = function () {
        this.functions = [];
    };

    n.FunctionList.prototype.addFunction = function (func, thisObj) {
        if (typeof func !== "function") {
            throw new TypeError("Expected function");
        }

        if (thisObj) {
            this.functions.push([func, thisObj]);
        } else {
            this.functions.push(func);
        }
    };

    n.FunctionList.prototype.call = function () {
        var _arguments = arguments;
        this.functions.forEach(function (func) {
            if (typeof func === "function") {
                func.apply(undefined, _arguments);
            } else {
                // func is an array [ Function, thisObj ]
                func[0].apply(func[1], _arguments);
            }
        });
    };
})(QfqNS.Helper);