<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 12/23/15
 * Time: 6:16 PM
 */

namespace qfq;

use qfq;

require_once(__DIR__ . '/../qfq/QuickFormQuery.php');
//require_once(__DIR__ . '/../qfq/store/Store.php');
require_once(__DIR__ . '/../qfq/Constants.php');


/**
 * Return JSON encoded answer
 *
 * status: success|error
 * message: <message>
 * redirect: client|url|no
 * redirect-url: <url>
 * field-name:<field name>
 * field-message: <message>
 *
 * Description:
 *
 * Delete successfull.
 *  status = 'success'
 *  message = <message>
 *  redirect = 'client'
 *
 * Delete successfull.
 *  status = 'success'
 *  message = <message>
 *  redirect = 'url'
 *  redirect-url = <URL>
 *
 * Delete failed: Show message.
 *  status = 'error'
 *  message = <message>
 *  redirect = 'no'
 */

$answer = array();

$answer[API_REDIRECT] = API_ANSWER_REDIRECT_NO;
$answer[API_MESSAGE] = '';
$answer[API_STATUS] = API_ANSWER_STATUS_ERROR;

try {

    $qfq = new \qfq\QuickFormQuery(['bodytext' => "debugShowStack=1"]);

    $qfq->delete();

    $answer[API_MESSAGE] = 'delete: success';
    $answer[API_REDIRECT] = API_ANSWER_REDIRECT_CLIENT;
    $answer[API_STATUS] = API_ANSWER_STATUS_SUCCESS;

} catch (qfq\UserException $e) {
    $answer[API_MESSAGE] = $e->formatMessage();
} catch (qfq\CodeException $e) {
    $answer[API_MESSAGE] = $e->formatMessage();
} catch (qfq\DbException $e) {
    $answer[API_MESSAGE] = $e->formatMessage();
} catch (\Exception $e) {
    $answer[API_MESSAGE] = "Generic Exception: " . $e->getMessage();
}

header("Content-Type: application/json");
echo json_encode($answer);

