<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 1/25/16
 * Time: 9:59 PM
 */

namespace qfq;

use qfq;

require_once(__DIR__ . '/../qfq/Constants.php');
require_once(__DIR__ . '/../qfq/AbstractBuildForm.php');

/**
 * Class BuildFormTable
 * @package qfq
 */
class BuildFormTable extends AbstractBuildForm {

    /**
     *
     */
    public function fillWrap() {
        $this->wrap[WRAP_SETUP_TITLE][WRAP_SETUP_START] = '<h3>';
        $this->wrap[WRAP_SETUP_TITLE][WRAP_SETUP_END] = '</h3>';

        $this->wrap[WRAP_SETUP_ELEMENT][WRAP_SETUP_START] = '<tr>';
        $this->wrap[WRAP_SETUP_ELEMENT][WRAP_SETUP_END] = '</tr>';

        $this->wrap[WRAP_SETUP_LABEL][WRAP_SETUP_START] = '<td align="right">';
        $this->wrap[WRAP_SETUP_LABEL][WRAP_SETUP_END] = '</td>';
        $this->wrap[WRAP_SETUP_INPUT][WRAP_SETUP_START] = '<td>';
        $this->wrap[WRAP_SETUP_INPUT][WRAP_SETUP_END] = '</td>';
        $this->wrap[WRAP_SETUP_NOTE][WRAP_SETUP_START] = '<td>';
        $this->wrap[WRAP_SETUP_NOTE][WRAP_SETUP_END] = '</td>';

        $this->wrap[WRAP_SETUP_SUBRECORD][WRAP_SETUP_START] = '<p>';
        $this->wrap[WRAP_SETUP_SUBRECORD][WRAP_SETUP_END] = '</p>';

        $this->wrap[WRAP_SETUP_IN_FIELDSET][WRAP_SETUP_START] = '<p>';
        $this->wrap[WRAP_SETUP_IN_FIELDSET][WRAP_SETUP_END] = '</p>';


    }

    /**
     * @return string
     */
    public function getProcessFilter() {
        return FORM_ELEMENTS_NATIVE;
    }

    /**
     * @return string
     */
    public function doSubrecords() {
        return $this->elements($this->store->getVar(SIP_RECORD_ID, STORE_SIP), FORM_ELEMENTS_SUBRECORD);
    }

    /**
     * @return string
     */
    public function head() {
        $html = '';

        $html .= '<div ' . $this->getAttribute('class', $this->formSpec['class'], TRUE) . '>'; // main <div class=...> around everything

        // Logged in BE User will see a FormEdit Link
        $sipParamString = OnArray::toString($this->store->getStore(STORE_SIP), ':', ', ', "'");
        $formEditUrl = $this->createFormEditUrl();
        $html .= "<p><a href='$formEditUrl'>Edit</a> <small>[$sipParamString]</small></p>";

        $deleteUrl = $this->createDeleteUrl($this->formSpec['tableName'], $this->store->getVar(SIP_RECORD_ID, STORE_SIP));
        $html .=  "<p><a href='$deleteUrl'>Delete</a>";

        $html .= $this->wrapItem(WRAP_SETUP_TITLE, $this->formSpec['title'], true);
        $html .= $this->getFormTag();
        $html .= '<table>';

        return $html;
    }

    /**
     * @param $htmlFormElementId
     * @param $formElement
     * @param $value
     * @return string
     */
    public function buildRowNative($formElement, $elementHtml) {
        $html = '';

        // Construct Marshaller Name
        $buildElementFunctionName = 'build' . $this->buildElementFunctionName[$formElement['type']];

        if ($formElement['type'] === 'subrecord') {
            // subrecord in render='table' are outside the table
            $html .= $this->wrapItem(WRAP_SETUP_SUBRECORD, $formElement['label']);
            $html .= $this->wrapItem(WRAP_SETUP_SUBRECORD, $elementHtml);
            $html .= $this->wrapItem(WRAP_SETUP_SUBRECORD, $formElement['note']);
        } else {
            if ($formElement['nestedInFieldSet'] === 'no') {
                $html .= $this->wrap[WRAP_SETUP_ELEMENT][WRAP_SETUP_START];
                $html .= $this->wrapItem(WRAP_SETUP_LABEL, $formElement['label']);
                $html .= $this->wrapItem(WRAP_SETUP_INPUT, $elementHtml);
                $html .= $this->wrapItem(WRAP_SETUP_NOTE, $formElement['note']);
                $html .= $this->wrap[WRAP_SETUP_ELEMENT][WRAP_SETUP_END];
            } else {
                $html .= $this->wrapItem(WRAP_SETUP_IN_FIELDSET, $formElement['label']);
                $html .= $this->wrapItem(WRAP_SETUP_IN_FIELDSET, $elementHtml);
                if($formElement['note']!=='')
                    $html .= $this->wrapItem(WRAP_SETUP_IN_FIELDSET, $formElement['note']);
            }
        }

        return $html;
    }

    /**
     * @return string
     */
    public function tail() {
        $html = '';


        $html .= $this->wrapItem(WRAP_SETUP_LABEL, '', false);
        $html .= $this->wrapItem(WRAP_SETUP_INPUT, '<input type="submit" value="Submit">');
        $html = $this->wrapItem(WRAP_SETUP_ELEMENT, $html);
        $html .= '</table>';
        $html .= $this->buildNewSip();
        $html .= '</form>';
        $html .= '</div>'; // main <div class=...> around everything


        return $html;
    }

    public function buildRowPill($formElement, $elementHtml) {
        // TODO: Implement buildRowPill() method.
    }

    public function buildRowFieldset($formElement, $elementHtml) {
        // TODO: Implement buildRowFieldset() method.
    }

    public function buildRowSubrecord($formElement, $elementHtml) {
        // TODO: Implement buildRowSubrecord() method.
    }
}