<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 1/29/16
 * Time: 8:03 AM
 */

namespace qfq;

require_once(__DIR__ . '/../../qfq/store/Store.php');


class AbstractException extends \Exception {

    public $messageArray = array();
    public $store;

    protected $file = '';
    protected $line = '';


    /**
     * @return string
     */
    public function formatException() {

        $this->messageArray['File'] = $this->getFile();
        $this->messageArray['Line'] =  $this->getLine();
        $this->messageArray['Message'] = $this->getMessage();
        $this->messageArray['Code'] = $this->getCode();


        if (Store::getVar('debugShowStack', STORE_TYPO3) === '1') {
            $this->messageArray['Stacktrace'] = '<pre>' . $this->getTraceAsString() . '</pre>';
        }

        // Layout
        $html = '<tr bgcolor="#dddddd"><td colspan="2">Exception</td></tr>';
        foreach ($this->messageArray as $key => $value) {
            if(is_array($value)) {
                $value = var_export($value, true);
            }
            $html .= "<tr>" . "<td>$key</td>" . "<td>$value</td>" . "</tr>";
        }

        return "<table border=1>" . $html . "</table>";
    }

}